> ## Documentation Index
> Fetch the complete documentation index at: https://docs.aihubmax.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Nanobanana Image Generation

> - Nano Banana 2 (gemini-3.1-flash-image-preview) model supports text-to-image, image-to-image, image editing, and other generation modes
- Async processing mode — use the returned task ID to [check task status](/pages/en/api-manual/task-management/get-task-detail)
- Generated image links are valid for 24 hours; please save them promptly




## OpenAPI

````yaml openapi/en/gemini-3.1-flash-image-preview.json POST /v1/images/generations
openapi: 3.1.0
info:
  title: Nano Banana 2
  version: '1.0'
servers:
  - url: https://api.aihubmax.com
security:
  - BearerAuth: []
paths:
  /v1/images/generations:
    post:
      tags:
        - Image > Nanobanana
      summary: Nano Banana 2
      description: >
        - Nano Banana 2 (gemini-3.1-flash-image-preview) model supports
        text-to-image, image-to-image, image editing, and other generation modes

        - Async processing mode — use the returned task ID to [check task
        status](/pages/en/api-manual/task-management/get-task-detail)

        - Generated image links are valid for 24 hours; please save them
        promptly
      operationId: gemini-3.1-flash-image-preview
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/GeminiImageGenRequest'
            examples:
              gemini_3_1_flash_text_to_image_1k:
                summary: Gemini 3.1 Flash — text-to-image (1K)
                value:
                  model: gemini-3.1-flash-image-preview
                  prompt: A futuristic city skyline at dusk, cyberpunk style
                  aspect_ratio: '16:9'
                  resolution: 1K
              gemini_3_1_flash_image_editing_with_image_search:
                summary: Gemini 3.1 Flash — image editing with image search
                value:
                  model: gemini-3.1-flash-image-preview
                  prompt: Replace the background with a tropical beach
                  image_urls:
                    - https://example.com/photo.jpg
                  aspect_ratio: match_input_image
                  resolution: 2K
                  image_search: true
      responses:
        '200':
          $ref: '#/components/responses/TaskCreated'
        '400':
          $ref: '#/components/responses/BadRequest'
        '401':
          $ref: '#/components/responses/Unauthorized'
        '402':
          $ref: '#/components/responses/PaymentRequired'
        '422':
          $ref: '#/components/responses/UnprocessableEntity'
        '429':
          $ref: '#/components/responses/TooManyRequests'
        '500':
          $ref: '#/components/responses/InternalServerError'
        '503':
          $ref: '#/components/responses/ServiceUnavailable'
components:
  schemas:
    GeminiImageGenRequest:
      type: object
      required:
        - model
        - prompt
      properties:
        model:
          description: >-
            `gemini-3.1-flash-image-preview`: Supports text-to-image,
            image-to-image, and image editing
          examples:
            - gemini-3.1-flash-image-preview
          type: string
          default: gemini-3.1-flash-image-preview
        prompt:
          description: >
            Image generation prompt


            **Notes:**

            - Text-to-image mode: describe the image content you want to
            generate

            - Image editing mode: describe the editing instructions for the
            reference image
          type: string
          example: A futuristic city skyline at dusk, cyberpunk style
        aspect_ratio:
          default: '1:1'
          description: >
            Output image aspect ratio


            **Model differences:**

            - `gemini-3.1-flash-image-preview`: available values include `1:1`,
            `1:4`, `1:8`, `2:3`, `3:2`, `3:4`, `4:1`, `4:3`, `4:5`, `5:4`,
            `8:1`, `9:16`, `16:9`, `21:9`, `match_input_image`

            - `gemini-3-pro-image-preview`: available values include `1:1`,
            `2:3`, `3:2`, `3:4`, `4:3`, `4:5`, `5:4`, `9:16`, `16:9`, `21:9`,
            `match_input_image`


            **Notes:**

            - `match_input_image` means the output will try to match the input
            image's aspect ratio
          type: string
          example: '1:1'
        resolution:
          default: 1K
          description: >
            Output image resolution


            **Model differences:**

            - `gemini-3.1-flash-image-preview`: supports `512`, `0.5K`, `1K`,
            `2K`, `4K`

            - `gemini-3-pro-image-preview`: supports `1K`, `2K`, `4K`


            **Notes:**

            - `512` and `0.5K` both represent half-size output

            - `1K`: approximately 1MP

            - `2K`: approximately 4MP

            - `4K`: approximately 16MP
          type: string
          example: '512'
        image_urls:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          default: null
          description: >
            Reference/editing image list


            **Model differences:**

            - `gemini-3.1-flash-image-preview`: supports image-to-image and
            image editing

            - `gemini-3-pro-image-preview`: supports image editing


            **Notes:**

            - When provided, the mode automatically switches to image editing

            - It is recommended to use publicly accessible image URLs
          example:
            - https://example.com/photo.jpg
        output_format:
          anyOf:
            - type: string
            - type: 'null'
          default: null
          description: |-
            Output format

            **Notes:**
            - Both models support this field
            - Common values: `jpg`, `png`, `webp`


            > Do not pass this parameter unless necessary.
          x-advanced: true
          example: png
        google_search:
          anyOf:
            - type: boolean
            - type: 'null'
          default: null
          description: >-
            Enable search for real-time information


            **Notes:**

            - Both `gemini-3.1-flash-image-preview` and
            `gemini-3-pro-image-preview` support this field



            > Do not pass this parameter unless necessary.
          x-advanced: true
          example: true
        image_search:
          anyOf:
            - type: boolean
            - type: 'null'
          default: null
          description: |-
            Enable image search to assist generation

            **Model differences:**
            - `gemini-3.1-flash-image-preview`: supported
            - `gemini-3-pro-image-preview`: not supported


            > Do not pass this parameter unless necessary.
          x-advanced: true
          example: true
    TaskResponse:
      type: object
      properties:
        created:
          type: integer
          description: Task creation timestamp
          example: 1757165031
        id:
          type: string
          description: Task ID
          example: task-unified-1757165031-uyujaw3d
        model:
          type: string
          description: Actual model name used
        object:
          type: string
          description: Specific task type
          enum:
            - image.generation.task
        progress:
          type: integer
          description: Task progress percentage (0-100)
          minimum: 0
          maximum: 100
          example: 0
        status:
          type: string
          description: Task status
          enum:
            - pending
            - processing
            - completed
            - failed
          example: pending
        task_info:
          type: object
          description: Async task information
          properties:
            can_cancel:
              type: boolean
              description: Whether the task can be cancelled
              example: true
            estimated_time:
              type: integer
              description: Estimated completion time (seconds)
              example: 45
        type:
          type: string
          description: Task output type
          enum:
            - image
          example: image
    ErrorResponse400:
      type: object
      properties:
        error:
          type: object
          properties:
            message:
              type: string
              example: Invalid request parameters
            type:
              type: string
              example: invalid_request_error
    ErrorResponse401:
      type: object
      properties:
        error:
          type: object
          properties:
            message:
              type: string
              example: Invalid API key
            type:
              type: string
              example: authentication_error
    ErrorResponse402:
      type: object
      properties:
        error:
          type: object
          properties:
            message:
              type: string
              example: Insufficient balance
            type:
              type: string
              example: insufficient_quota
    ErrorResponse422:
      type: object
      properties:
        error:
          type: object
          properties:
            message:
              type: string
              example: Parameter validation failed
            type:
              type: string
              example: validation_error
    ErrorResponse429:
      type: object
      properties:
        error:
          type: object
          properties:
            message:
              type: string
              example: Rate limit exceeded
            type:
              type: string
              example: rate_limit_error
    ErrorResponse500:
      type: object
      properties:
        error:
          type: object
          properties:
            message:
              type: string
              example: Internal server error
            type:
              type: string
              example: server_error
    ErrorResponse503:
      type: object
      properties:
        error:
          type: object
          properties:
            message:
              type: string
              example: Service temporarily unavailable, please try again later
            type:
              type: string
              example: service_unavailable
  responses:
    TaskCreated:
      description: Task created successfully
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/TaskResponse'
    BadRequest:
      description: Bad Request
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponse400'
    Unauthorized:
      description: Unauthorized
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponse401'
    PaymentRequired:
      description: Insufficient balance
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponse402'
    UnprocessableEntity:
      description: Parameter validation failed
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponse422'
    TooManyRequests:
      description: Too Many Requests
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponse429'
    InternalServerError:
      description: Internal Server Error
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponse500'
    ServiceUnavailable:
      description: Service Unavailable
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponse503'
  securitySchemes:
    BearerAuth:
      type: http
      scheme: bearer
      description: |
        ## All APIs require Bearer Token authentication ##

        Add to request header:

        `Authorization: Bearer YOUR_API_KEY`

````